"use strickt";

//  Теоретичні питання
//  1. Опишіть своїми словами, що таке метод об'єкту.

// Метод об'єкту - це функція яка виконується всередені об'єкта.

//  2. Який тип даних може мати значення властивості об'єкта?
// Значенням об'єкта може бути будь який тип данних: числа, рядки, логічні значення, null та undefined, функції, інщі об`єтки.

let person = {
  name: "Vasya",
  age: 18,
  isWoman: false,
  address: {
    city: "Kyiv",
    zip: "61145",
  },
  sayHello: function () {
    console.log("Hello!");
  },
};

//  3. Об'єкт це посилальний тип даних. Що означає це поняття?

// Коли об'єкт присвоюється змінній або передається як аргумент функції, змінна отримує не сам об'єкт, а посилання (силку) на об'єкт у пам'яті. Посилання дозволяє працювати з одним об'єктом з різних частинах програми, і якщо ви змінюєте стан об'єкта в одному місці, зміни відобразяться в усіх інших місцях, де використовується те саме посилання.
let obj1 = { name: "Vasya" };
let obj2 = obj1;

obj2.name = "Petya";

console.log(obj1.name);
console.log(obj2.name);

//  Практичні завдання
//  1. Створіть об'єкт product з властивостями name, price та discount. Додайте метод для виведення повної ціни товару з урахуванням знижки. Викличте цей метод та результат виведіть в консоль.

let product = {
  name: `Laptop`,
  price: 1000,
  discount: 0.1,
  getDiscount: function () {
    return this.price * (1 - this.discount);
  },
};
console.log(product.getDiscount());

//  2. Напишіть функцію, яка приймає об'єкт з властивостями name та age, і повертає рядок з привітанням і віком,
//  наприклад "Привіт, мені 30 років".

// Попросіть користувача ввести своє ім'я та вік за допомогою prompt,
// і викличте функцію з введеними даними.
// Результат виклику функції виведіть з допомогою alert.

function greeting(person2) {
  let name;
  let age;

  while (true) {
    name = prompt(`Введіть своє ім'я:`);
    if (name !== null && name !== "") {
      break;
    } else {
      alert(
        `Ви відмінили введення або не ввели ім'я. Будь ласка, спробуйте ще раз.`
      );
    }
  }
  while (true) {
    age = prompt(`Введіть свій вік:`);
    if (age !== null && age !== "" && !isNaN(age)) {
      break;
    } else {
      alert(
        `Ви відмінили введення, не ввели вік або ввели некоректне значення. Будь ласка, спробуйте ще раз.`
      );
    }
  }
  person2.name = name;
  person2.age = age;
  console.log(person2);
  return alert(`Привіт! Моє ім'я: ${name}, мені: ${age}р.`);
}
const person2 = {};
greeting(person2);

// 3.Опціональне. Завдання:
// Реалізувати повне клонування об'єкта.

//     const person = {
//         name: "John",
//         surname: "Blackwood",
//         job: "carpenter",

//         family: {
//             count: 3,
//             members: {
//                 mother: {},
//                 father: {},
//                 sister: {},
//             },
//         },
//     };

//     const person2 = ...

//     person2.name = "Galya";

//     console.log(person2.name); // "Galya"
//     console.log(person.name); // "John"

// Технічні вимоги:
// - Написати функцію для рекурсивного повного клонування об'єкта (без єдиної передачі за посиланням, внутрішня вкладеність властивостей об'єкта може бути досить великою).
// - Функція має успішно копіювати властивості у вигляді об'єктів та масивів на будь-якому рівні вкладеності.
// - У коді не можна використовувати вбудовані механізми клонування, такі як функція Object.assign() або spread.
